## dpf-plugins 1.6+ds

=== Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#

include dpf/Makefile.base.mk

all: dgl plugins resources gen

# --------------------------------------------------------------

PREFIX  ?= /usr/local
DESTDIR ?=

# --------------------------------------------------------------
# Check for system-wide projectM

HAVE_PROJECTM = $(shell pkg-config --exists libprojectM && echo true)

# --------------------------------------------------------------

ifneq ($(CROSS_COMPILING),true)
CAN_GENERATE_TTL = true
else ifneq ($(EXE_WRAPPER),)
CAN_GENERATE_TTL = true
endif

dgl:
ifeq ($(HAVE_CAIRO_OR_OPENGL),true)
	$(MAKE) FILE_BROWSER_DISABLED=true -C dpf/dgl
ifeq ($(HAVE_OPENGL),true)
	$(MAKE) FILE_BROWSER_DISABLED=true -C dpf/dgl opengl3
endif
endif

plugins: dgl
	# Kars
	$(MAKE) all -C plugins/Kars

	# Mini-Series
	$(MAKE) all -C plugins/3BandEQ
	$(MAKE) all -C plugins/3BandSplitter
	$(MAKE) all -C plugins/PingPongPan

	# ndc-Plugs
	$(MAKE) all -C plugins/AmplitudeImposer
	$(MAKE) all -C plugins/CycleShifter
	$(MAKE) all -C plugins/SoulForce

	# MVerb
	$(MAKE) all -C plugins/MVerb

	# Nekobi
	$(MAKE) all -C plugins/Nekobi

	# Max-Gen stuff
	$(MAKE) all -C plugins/bitcrush
	$(MAKE) all -C plugins/freeverb
	$(MAKE) all -C plugins/gigaverb
	$(MAKE) all -C plugins/pitchshift

ifeq ($(HAVE_OPENGL),true)
	# glBars (needs OpenGL)
	$(MAKE) all -C plugins/glBars

	# ProM (needs OpenGL, ProjectM can be from system or vendored)
	$(MAKE) all -C plugins/ProM
endif # HAVE_OPENGL

ifeq ($(HAVE_OPENGL),true)
resources: gen
ifneq ($(HAVE_PROJECTM),true)
	# LV2 fonts
	install -d bin/ProM.lv2/resources/fonts
	ln -sf $(CURDIR)/plugins/ProM/projectM/fonts/*.ttf bin/ProM.lv2/resources/fonts/
	# LV2 presets
	install -d bin/ProM.lv2/resources/presets
	ln -sf $(CURDIR)/plugins/ProM/projectM/presets/presets_* bin/ProM.lv2/resources/presets/

ifeq ($(MACOS),true)
	# CLAP + VST2 fonts
	install -d bin/ProM.clap/Contents/Resources/fonts
	install -d bin/ProM.vst/Contents/Resources/fonts
	ln -sf $(CURDIR)/plugins/ProM/projectM/fonts/*.ttf bin/ProM.clap/Contents/Resources/fonts/
	ln -sf $(CURDIR)/plugins/ProM/projectM/fonts/*.ttf bin/ProM.vst/Contents/Resources/fonts/
	# CLAP + VST2 presets
	install -d bin/ProM.clap/Contents/Resources/presets
	install -d bin/ProM.vst/Contents/Resources/presets
	ln -sf $(CURDIR)/plugins/ProM/projectM/presets/presets_* bin/ProM.clap/Contents/Resources/presets/
	ln -sf $(CURDIR)/plugins/ProM/projectM/presets/presets_* bin/ProM.vst/Contents/Resources/presets/
else
	# CLAP + VST2 fonts
	install -d bin/ProM.clap/resources/fonts
	install -d bin/ProM.vst/resources/fonts
	ln -sf $(CURDIR)/plugins/ProM/projectM/fonts/*.ttf bin/ProM.clap/resources/fonts/
	ln -sf $(CURDIR)/plugins/ProM/projectM/fonts/*.ttf bin/ProM.vst/resources/fonts/
	# CLAP + VST2 presets
	install -d bin/ProM.clap/resources/presets
	install -d bin/ProM.vst/resources/presets
	ln -sf $(CURDIR)/plugins/ProM/projectM/presets/presets_* bin/ProM.clap/resources/presets/
	ln -sf $(CURDIR)/plugins/ProM/projectM/presets/presets_* bin/ProM.vst/resources/presets/
endif

	# VST3 fonts
	install -d bin/ProM.vst3/Contents/Resources/fonts
	ln -sf $(CURDIR)/plugins/ProM/projectM/fonts/*.ttf bin/ProM.vst3/Contents/Resources/fonts/
	# VST3 presets
	install -d bin/ProM.vst3/Contents/Resources/presets
	ln -sf $(CURDIR)/plugins/ProM/projectM/presets/presets_* bin/ProM.vst3/Contents/Resources/presets/
endif
else
resources:
endif

gen: plugins dpf/utils/lv2_ttl_generator
ifeq ($(CAN_GENERATE_TTL),true)
	@$(CURDIR)/dpf/utils/generate-ttl.sh
endif

dpf/utils/lv2_ttl_generator:
	$(MAKE) -C dpf/utils/lv2-ttl-generator

# --------------------------------------------------------------

clean:
	rm -rf bin build

	$(MAKE) clean -C dpf/dgl
	$(MAKE) clean -C dpf/utils/lv2-ttl-generator

	# glBars
	$(MAKE) clean -C plugins/glBars

	# Kars
	$(MAKE) clean -C plugins/Kars

	# Mini-Series
	$(MAKE) clean -C plugins/3BandEQ
	$(MAKE) clean -C plugins/3BandSplitter
	$(MAKE) clean -C plugins/PingPongPan

	# ndc-Plugs
	$(MAKE) clean -C plugins/AmplitudeImposer
	$(MAKE) clean -C plugins/CycleShifter
	$(MAKE) clean -C plugins/SoulForce

	# MVerb
	$(MAKE) clean -C plugins/MVerb

	# Nekobi
	$(MAKE) clean -C plugins/Nekobi

	# ProM
	$(MAKE) clean -C plugins/ProM

	# Max-Gen stuff
	$(MAKE) clean -C plugins/bitcrush
	$(MAKE) clean -C plugins/freeverb
	$(MAKE) clean -C plugins/gigaverb
	$(MAKE) clean -C plugins/pitchshift

# --------------------------------------------------------------

install:
	install -d $(DESTDIR)$(PREFIX)/lib/ladspa/
	install -d $(DESTDIR)$(PREFIX)/lib/dssi/
	install -d $(DESTDIR)$(PREFIX)/lib/lv2/
	install -d $(DESTDIR)$(PREFIX)/lib/vst/
	install -d $(DESTDIR)$(PREFIX)/lib/vst3/
	install -d $(DESTDIR)$(PREFIX)/lib/clap/
	install -d $(DESTDIR)$(PREFIX)/bin/

	install -m 644 bin/*-ladspa.* $(DESTDIR)$(PREFIX)/lib/ladspa/
	install -m 644 bin/*-dssi.*   $(DESTDIR)$(PREFIX)/lib/dssi/
ifneq ($(MACOS),true)
	install -m 644 bin/*-vst.*    $(DESTDIR)$(PREFIX)/lib/vst/
endif

ifeq ($(HAVE_CAIRO_OR_OPENGL),true)
ifeq ($(HAVE_LIBLO),true)
	cp -r  bin/*-dssi $(DESTDIR)$(PREFIX)/lib/dssi/
endif # HAVE_LIBLO
endif # HAVE_CAIRO_OR_OPENGL
	cp -rL bin/*.lv2  $(DESTDIR)$(PREFIX)/lib/lv2/
ifeq ($(HAVE_OPENGL),true)
	cp -rL bin/*.vst  $(DESTDIR)$(PREFIX)/lib/vst/
endif # HAVE_OPENGL
	cp -rL bin/*.vst3 $(DESTDIR)$(PREFIX)/lib/vst3/
	cp -rL bin/*.clap $(DESTDIR)$(PREFIX)/lib/clap/

	install -m 755 bin/Kars$(APP_EXT)             $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/3BandEQ$(APP_EXT)          $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/3BandSplitter$(APP_EXT)    $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/PingPongPan$(APP_EXT)      $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/AmplitudeImposer$(APP_EXT) $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/CycleShifter$(APP_EXT)     $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/SoulForce$(APP_EXT)        $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/MVerb$(APP_EXT)            $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/Nekobi$(APP_EXT)           $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/MaBitcrush$(APP_EXT)       $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/MaFreeverb$(APP_EXT)       $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/MaGigaverb$(APP_EXT)       $(DESTDIR)$(PREFIX)/bin/
	install -m 755 bin/MaPitchshift$(APP_EXT)     $(DESTDIR)$(PREFIX)/bin/
ifeq ($(HAVE_OPENGL),true)
	install -m 755 bin/glBars$(APP_EXT)           $(DESTDIR)$(PREFIX)/bin/
endif # HAVE_OPENGL

# --------------------------------------------------------------

.PHONY: plugins

=== dpf/CMakeLists.txt ===
# DISTRHO Plugin Framework (DPF)
# Copyright (C) 2021 Jean Pierre Cimalando <jp-dev@inbox.ru>
#
# SPDX-License-Identifier: ISC

cmake_minimum_required(VERSION 3.7)

project(DPF)

# ensure c++11 at minimum, the parent project can override
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 11)
endif()

# check if we are building from this project, or are imported by another
if(PROJECT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
  set(DPF_BUILD_FROM_HERE TRUE)
else()
  set(DPF_BUILD_FROM_HERE FALSE)
endif()

option(DPF_LIBRARIES "Build the libraries" "${DPF_BUILD_FROM_HERE}")
option(DPF_EXAMPLES "Build the examples" "${DPF_BUILD_FROM_HERE}")

set(DPF_ROOT_DIR "${PROJECT_SOURCE_DIR}" CACHE INTERNAL
  "Root directory of the DISTRHO Plugin Framework.")

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
include(DPF-plugin)

if(DPF_LIBRARIES)
  if(NOT (MSVC OR APPLE)) # TODO skip this one for now
    dpf__add_dgl_cairo()
  endif()
  dpf__add_dgl_opengl()
endif()

if(DPF_EXAMPLES)
  if(NOT (MSVC OR APPLE)) # TODO skip this one for now
    add_subdirectory("examples/CairoUI")
  endif()
  #add_subdirectory("examples/ExternalUI")
  add_subdirectory("examples/FileHandling")
  add_subdirectory("examples/Info")
  add_subdirectory("examples/Latency")
  add_subdirectory("examples/Meters")
  add_subdirectory("examples/MidiThrough")
  add_subdirectory("examples/Parameters")
  add_subdirectory("examples/States")
endif()

=== dpf/dgl/Makefile ===
#!/usr/bin/make -f
# Makefile for DGL #
# ---------------- #
# Created by falkTX
#

include ../Makefile.base.mk

# ---------------------------------------------------------------------------------------------------------------------

BUILD_C_FLAGS   += $(DGL_FLAGS) -I. -Isrc
BUILD_CXX_FLAGS += $(DGL_FLAGS) -I. -Isrc -DDONT_SET_USING_DGL_NAMESPACE -Wno-unused-parameter
BUILD_CXX_FLAGS += -Isrc/pugl-upstream/include
LINK_FLAGS      += $(DGL_LIBS)

ifeq ($(MACOS),true)
BUILD_CXX_FLAGS += -Wno-deprecated-declarations
else
PUGL_EXTRA_FLAGS = -Wno-extra -Wmissing-field-initializers
endif

# ifneq ($(MACOS_OLD),true)
# needed by sofd right now, fix later
# BUILD_CXX_FLAGS += -Wno-type-limits -fpermissive
# endif

# ---------------------------------------------------------------------------------------------------------------------

OBJS_common = \
	../build/dgl/Application.cpp.o \
	../build/dgl/ApplicationPrivateData.cpp.o \
	../build/dgl/Color.cpp.o \
	../build/dgl/EventHandlers.cpp.o \
	../build/dgl/Geometry.cpp.o \
	../build/dgl/ImageBase.cpp.o \
	../build/dgl/ImageBaseWidgets.cpp.o \
	../build/dgl/Layout.cpp.o \
	../build/dgl/Resources.cpp.o \
	../build/dgl/SubWidget.cpp.o \
	../build/dgl/SubWidgetPrivateData.cpp.o \
	../build/dgl/TopLevelWidget.cpp.o \
	../build/dgl/TopLevelWidgetPrivateData.cpp.o \
	../build/dgl/Widget.cpp.o \
	../build/dgl/WidgetPrivateData.cpp.o \
	../build/dgl/Window.cpp.o \
	../build/dgl/WindowPrivateData.cpp.o

# ---------------------------------------------------------------------------------------------------------------------

OBJS_cairo = $(OBJS_common) \
	../build/dgl/Cairo.cpp.cairo.o

ifeq ($(MACOS),true)
OBJS_cairo += ../build/dgl/pugl.mm.cairo.o
else
OBJS_cairo += ../build/dgl/pugl.cpp.cairo.o
endif

# ---------------------------------------------------------------------------------------------------------------------

OBJS_opengl = $(OBJS_common) \
	../build/dgl/OpenGL.cpp.opengl.o \
	../build/dgl/NanoVG.cpp.opengl.o

ifeq ($(MACOS),true)
OBJS_opengl += ../build/dgl/pugl.mm.opengl.o
else
OBJS_opengl += ../build/dgl/pugl.cpp.opengl.o
endif

# ---------------------------------------------------------------------------------------------------------------------

OBJS_opengl3 = $(OBJS_common) \
	../build/dgl/OpenGL.cpp.opengl3.o \
	../build/dgl/NanoVG.cpp.opengl3.o

ifeq ($(MACOS),true)
OBJS_opengl3 += ../build/dgl/pugl.mm.opengl3.o
else
OBJS_opengl3 += ../build/dgl/pugl.cpp.opengl3.o
endif

# ---------------------------------------------------------------------------------------------------------------------

OBJS_stub = $(OBJS_common)

ifeq ($(MACOS),true)
OBJS_stub += ../build/dgl/pugl.mm.o
else
OBJS_stub += ../build/dgl/pugl.cpp.o
endif

# ---------------------------------------------------------------------------------------------------------------------

OBJS_vulkan = $(OBJS_common) \
	../build/dgl/Vulkan.cpp.vulkan.o

ifeq ($(MACOS),true)
OBJS_vulkan += ../build/dgl/pugl.mm.vulkan.o
else
OBJS_vulkan += ../build/dgl/pugl.cpp.vulkan.o
endif

# ---------------------------------------------------------------------------------------------------------------------

ifeq ($(HAVE_CAIRO),true)
TARGETS += ../build/libdgl-cairo.a
endif

ifeq ($(HAVE_OPENGL),true)
TARGETS += ../build/libdgl-opengl.a
# Compat name, to be removed soon
TARGETS += ../build/libdgl.a
endif

ifeq ($(HAVE_STUB),true)
TARGETS += ../build/libdgl-stub.a
endif

ifeq ($(HAVE_VULKAN),true)
TARGETS += ../build/libdgl-vulkan.a
endif

# ---------------------------------------------------------------------------------------------------------------------

all: $(TARGETS)

cairo:   ../build/libdgl-cairo.a
opengl:  ../build/libdgl-opengl.a
opengl3: ../build/libdgl-opengl3.a
stub:    ../build/libdgl-stub.a
vulkan:  ../build/libdgl-vulkan.a

# ---------------------------------------------------------------------------------------------------------------------

../build/libdgl-cairo.a: $(OBJS_cairo)
	-@mkdir -p ../build
	@echo "Creating libdgl-cairo.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

../build/libdgl-opengl.a: $(OBJS_opengl)
	-@mkdir -p ../build
	@echo "Creating libdgl-opengl.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

../build/libdgl-opengl3.a: $(OBJS_opengl3)
	-@mkdir -p ../build
	@echo "Creating libdgl-opengl3.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

../build/libdgl-stub.a: $(OBJS_stub)
	-@mkdir -p ../build
	@echo "Creating libdgl-stub.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

../build/libdgl-vulkan.a: $(OBJS_vulkan)
	-@mkdir -p ../build
	@echo "Creating libdgl-vulkan.a"
	$(SILENT)rm -f $@
	$(SILENT)$(AR) crs $@ $^

# Compat name, to be removed soon
../build/libdgl.a: ../build/libdgl-opengl.a
	@echo "Symlinking libdgl.a"
	$(SILENT)ln -sf $< $@

# ---------------------------------------------------------------------------------------------------------------------

../build/dgl/%.c.o: src/%.c
	-@mkdir -p ../build/dgl
	@echo "Compiling $<"
	$(SILENT)$(CC) $< $(BUILD_C_FLAGS) -c -o $@

../build/dgl/%.cpp.o: src/%.cpp
	-@mkdir -p ../build/dgl
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) -c -o $@

../build/dgl/%.mm.o: src/%.mm
	-@mkdir -p ../build/dgl
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) -c -ObjC++ -o $@

# ---------------------------------------------------------------------------------------------------------------------

../build/dgl/pugl.cpp.o: src/pugl.cpp
	-@mkdir -p ../build/dgl
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) -c -o $@

../build/dgl/pugl.mm.o: src/pugl.mm
	-@mkdir -p ../build/dgl
	@echo "Compiling $<"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) -c -ObjC++ -o $@

# ---------------------------------------------------------------------------------------------------------------------

../build/dgl/%.cpp.cairo.o: src/%.cpp
	-@mkdir -p ../build/dgl
	@echo "Compiling $< (Cairo variant)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) $(CAIRO_FLAGS) -DDGL_CAIRO -c -o $@

../build/dgl/%.mm.cairo.o: src/%.mm
	-@mkdir -p ../build/dgl
	@echo "Compiling $< (Cairo variant)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) $(CAIRO_FLAGS) -DDGL_CAIRO -c -ObjC++ -o $@

# ---------------------------------------------------------------------------------------------------------------------

../build/dgl/%.cpp.opengl.o: src/%.cpp
	-@mkdir -p ../build/dgl
	@echo "Compiling $< (OpenGL variant)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) $(OPENGL_FLAGS) -DDGL_OPENGL -c -o $@

../build/dgl/%.mm.opengl.o: src/%.mm
	-@mkdir -p ../build/dgl
	@echo "Compiling $< (OpenGL variant)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) $(OPENGL_FLAGS) -DDGL_OPENGL -c -ObjC++ -o $@

# ---------------------------------------------------------------------------------------------------------------------

../build/dgl/%.cpp.opengl3.o: src/%.cpp
	-@mkdir -p ../build/dgl
	@echo "Compiling $< (OpenGL3 variant)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) $(OPENGL_FLAGS) -DDGL_OPENGL -DDGL_USE_OPENGL3 -c -o $@

../build/dgl/%.mm.opengl3.o: src/%.mm
	-@mkdir -p ../build/dgl
	@echo "Compiling $< (OpenGL3 variant)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) $(OPENGL_FLAGS) -DDGL_OPENGL -DDGL_USE_OPENGL3 -c -ObjC++ -o $@

# ---------------------------------------------------------------------------------------------------------------------

../build/dgl/%.cpp.vulkan.o: src/%.cpp
	-@mkdir -p ../build/dgl
	@echo "Compiling $< (Vulkan variant)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) $(VULKAN_FLAGS) -DDGL_VULKAN -c -o $@

../build/dgl/%.mm.vulkan.o: src/%.mm
	-@mkdir -p ../build/dgl
	@echo "Compiling $< (Vulkan variant)"
	$(SILENT)$(CXX) $< $(BUILD_CXX_FLAGS) $(PUGL_EXTRA_FLAGS) $(VULKAN_FLAGS) -DDGL_VULKAN -c -ObjC++ -o $@

# ---------------------------------------------------------------------------------------------------------------------

clean:
	rm -rf ../build/dgl ../build/libdgl*.*

debug:
	$(MAKE) DEBUG=true

# ---------------------------------------------------------------------------------------------------------------------

-include $(OBJS_common:%.o=%.d)
-include $(OBJS_cairo:%.o=%.d)
-include $(OBJS_opengl:%.o=%.d)
-include $(OBJS_opengl3:%.o=%.d)
-include $(OBJS_stub:%.o=%.d)
-include $(OBJS_vulkan:%.o=%.d)

# ---------------------------------------------------------------------------------------------------------------------

=== plugins/3BandEQ/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#

# --------------------------------------------------------------
# Project name, used for binaries

NAME = 3BandEQ

# --------------------------------------------------------------
# Files to build

FILES_DSP = \
	DistrhoPlugin3BandEQ.cpp

FILES_UI  = \
	DistrhoArtwork3BandEQ.cpp \
	DistrhoUI3BandEQ.cpp

# --------------------------------------------------------------
# Do some magic

UI_TYPE = generic
FILE_BROWSER_DISABLED = true
include ../../dpf/Makefile.plugins.mk

# --------------------------------------------------------------
# Enable all possible plugin types

TARGETS = jack ladspa lv2_sep vst2 vst3 clap

ifeq ($(HAVE_CAIRO_OR_OPENGL),true)
ifeq ($(HAVE_LIBLO),true)
TARGETS += dssi
endif
endif

all: $(TARGETS)

# --------------------------------------------------------------

=== plugins/AmplitudeImposer/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#

# --------------------------------------------------------------
# Project name, used for binaries

NAME = AmplitudeImposer

# --------------------------------------------------------------
# Files to build

FILES_DSP = \
	DistrhoPluginAmplitudeImposer.cpp

FILES_UI  = \
	DistrhoArtworkAmplitudeImposer.cpp \
	DistrhoUIAmplitudeImposer.cpp

# --------------------------------------------------------------
# Do some magic

UI_TYPE = generic
FILE_BROWSER_DISABLED = true
include ../../dpf/Makefile.plugins.mk

# --------------------------------------------------------------
# Enable all possible plugin types

TARGETS += clap
TARGETS += jack
TARGETS += ladspa
TARGETS += lv2_sep
TARGETS += vst2
TARGETS += vst3

ifeq ($(HAVE_CAIRO_OR_OPENGL),true)
ifeq ($(HAVE_LIBLO),true)
TARGETS += dssi
endif
endif

all: $(TARGETS)

# --------------------------------------------------------------

=== plugins/MVerb/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#

# --------------------------------------------------------------
# Project name, used for binaries

NAME = MVerb

# --------------------------------------------------------------
# Files to build

FILES_DSP = \
	DistrhoPluginMVerb.cpp

FILES_UI  = \
	DistrhoArtworkMVerb.cpp \
	DistrhoUIMVerb.cpp

# --------------------------------------------------------------
# Do some magic

FILE_BROWSER_DISABLED = true
include ../../dpf/Makefile.plugins.mk

# --------------------------------------------------------------
# Enable all possible plugin types

TARGETS = jack ladspa lv2_sep vst2 vst3 clap

ifeq ($(HAVE_DGL),true)
ifeq ($(HAVE_LIBLO),true)
TARGETS += dssi
endif
endif

all: $(TARGETS)

# --------------------------------------------------------------

=== plugins/ProM/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#

# --------------------------------------------------------------
# Project name, used for binaries

NAME = ProM

# --------------------------------------------------------------
# Files to build

FILES_DSP = \
	DistrhoPluginProM.cpp

FILES_UI  = \
	DistrhoUIProM.cpp

# --------------------------------------------------------------
# Check for system-wide projectM

HAVE_PROJECTM = $(shell pkg-config --exists libprojectM && echo true)

# --------------------------------------------------------------
# Import base definitions

FILE_BROWSER_DISABLED = true
include ../../dpf/Makefile.base.mk

# --------------------------------------------------------------
# Use local copy if needed

ifneq ($(HAVE_PROJECTM),true)
FILES_UI += \
	projectM/src/libprojectM/ConfigFile.cpp \
	projectM/src/libprojectM/FileScanner.cpp \
	projectM/src/libprojectM/KeyHandler.cpp \
	projectM/src/libprojectM/PCM.cpp \
	projectM/src/libprojectM/PipelineMerger.cpp \
	projectM/src/libprojectM/Preset.cpp \
	projectM/src/libprojectM/PresetChooser.cpp \
	projectM/src/libprojectM/PresetFactory.cpp \
	projectM/src/libprojectM/PresetFactoryManager.cpp \
	projectM/src/libprojectM/PresetLoader.cpp \
	projectM/src/libprojectM/TimeKeeper.cpp \
	projectM/src/libprojectM/fftsg.cpp \
	projectM/src/libprojectM/projectM.cpp \
	projectM/src/libprojectM/timer.cpp \
	projectM/src/libprojectM/wipemalloc.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/BuiltinFuncs.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/BuiltinParams.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/CustomShape.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/CustomWave.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/Eval.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/Expr.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/Func.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/IdlePreset.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/InitCond.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/MilkdropPreset.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/MilkdropPresetFactory.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/Param.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/Parser.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/PerFrameEqn.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/PerPixelEqn.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/PerPointEqn.cpp \
	projectM/src/libprojectM/MilkdropPresetFactory/PresetFrameIO.cpp \
	projectM/src/libprojectM/NativePresetFactory/NativePresetFactory.cpp \
	projectM/src/libprojectM/Renderer/BeatDetect.cpp \
	projectM/src/libprojectM/Renderer/Renderable.cpp \
	projectM/src/libprojectM/Renderer/Filters.cpp \
	projectM/src/libprojectM/Renderer/Renderer.cpp \
	projectM/src/libprojectM/Renderer/MilkdropWaveform.cpp \
	projectM/src/libprojectM/Renderer/Shader.cpp \
	projectM/src/libprojectM/Renderer/PerPixelMesh.cpp \
	projectM/src/libprojectM/Renderer/ShaderEngine.cpp \
	projectM/src/libprojectM/Renderer/PerlinNoise.cpp \
	projectM/src/libprojectM/Renderer/StaticGlShaders.cpp \
	projectM/src/libprojectM/Renderer/PerlinNoiseWithAlpha.cpp \
	projectM/src/libprojectM/Renderer/Texture.cpp \
	projectM/src/libprojectM/Renderer/Pipeline.cpp \
	projectM/src/libprojectM/Renderer/TextureManager.cpp \
	projectM/src/libprojectM/Renderer/PipelineContext.cpp \
	projectM/src/libprojectM/Renderer/VideoEcho.cpp \
	projectM/src/libprojectM/Renderer/RenderItemDistanceMetric.cpp \
	projectM/src/libprojectM/Renderer/Waveform.cpp \
	projectM/src/libprojectM/Renderer/RenderItemMatcher.cpp \
	projectM/src/libprojectM/Renderer/hlslparser/src/CodeWriter.cpp \
	projectM/src/libprojectM/Renderer/hlslparser/src/HLSLParser.cpp \
	projectM/src/libprojectM/Renderer/hlslparser/src/Engine.cpp \
	projectM/src/libprojectM/Renderer/hlslparser/src/HLSLTokenizer.cpp \
	projectM/src/libprojectM/Renderer/hlslparser/src/GLSLGenerator.cpp \
	projectM/src/libprojectM/Renderer/hlslparser/src/HLSLTree.cpp \
	projectM/src/libprojectM/Renderer/SOIL2/SOIL2.c \
	projectM/src/libprojectM/Renderer/SOIL2/image_DXT.c \
	projectM/src/libprojectM/Renderer/SOIL2/etc1_utils.c \
	projectM/src/libprojectM/Renderer/SOIL2/image_helper.c
ifeq ($(WINDOWS),true)
FILES_UI += \
	projectM/msvc/dlfcn.c \
	projectM/msvc/GL/glew.c
endif # WINDOWS
endif # !HAVE_PROJECTM

# --------------------------------------------------------------
# Do some magic

UI_TYPE = opengl3
USE_CLAP_BUNDLE = true
USE_VST2_BUNDLE = true
include ../../dpf/Makefile.plugins.mk

# --------------------------------------------------------------
# Extra flags

ifeq ($(HAVE_PROJECTM),true)

BASE_FLAGS += -DPROJECTM_DATA_DIR='"$(shell pkg-config --variable=pkgdatadir libprojectM)"'
BASE_FLAGS += $(shell pkg-config --cflags libprojectM)
LINK_FLAGS += $(shell pkg-config --libs libprojectM)

ifeq ($(shell pkg-config --atleast-version=3.1.8 libprojectM && echo true),true)
BASE_FLAGS += -DHAVE_PROJECTM_TEXT_FUNCTIONS
endif

else # HAVE_PROJECTM

# custom macros for ProM
BASE_FLAGS += -DHAVE_PROJECTM_TEXT_FUNCTIONS

# compiler macros from projectM
BASE_FLAGS += -DUSE_TEXT_MENU=1
BASE_FLAGS += -DUSE_THREADS=1
# GLES stuff
# BASE_FLAGS += -DUSE_GLES=1
# Experimental
# BASE_FLAGS += -DHAVE_LLVM=1
ifeq ($(WINDOWS),true)
BASE_FLAGS += -DDLLEXPORT=
BASE_FLAGS += -DprojectM_FONT_TITLE='"fonts/Vera.tff"'
BASE_FLAGS += -DprojectM_FONT_MENU='"fonts/VeraMono.ttf"'
BASE_FLAGS += -DSTBI_NO_DDS=1
else # WINDOWS
BASE_FLAGS += -DDATADIR_PATH='"."'
BASE_FLAGS += -DHAVE_ALIGNED_ALLOC=1
BASE_FLAGS += -DHAVE_FTS_H=1
BASE_FLAGS += -DHAVE_POSIX_MEMALIGN=1
endif # WINDOWS

# include dirs
BASE_FLAGS += -IprojectM/src
BASE_FLAGS += -IprojectM/src/libprojectM
BASE_FLAGS += -IprojectM/src/libprojectM/Renderer
BASE_FLAGS += -IprojectM/src/libprojectM/Renderer/hlslparser/src
BASE_FLAGS += -IprojectM/src/libprojectM/MilkdropPresetFactory
BASE_FLAGS += -IprojectM/src/libprojectM/NativePresetFactory
BASE_FLAGS += -IprojectM/vendor
ifeq ($(WINDOWS),true)
BASE_FLAGS += -IprojectM/msvc
endif # WINDOWS

# silence projectM warnings
BASE_FLAGS += -Wno-ignored-qualifiers
BASE_FLAGS += -Wno-implicit-fallthrough
BASE_FLAGS += -Wno-overflow
BASE_FLAGS += -Wno-shift-negative-value
BASE_FLAGS += -Wno-sign-compare
BASE_FLAGS += -Wno-unused-parameter
BASE_FLAGS += -Wno-unused-variable
ifeq ($(MACOS),true)
BASE_FLAGS += -Wno-constant-conversion
BASE_FLAGS += -Wno-delete-non-abstract-non-virtual-dtor
BASE_FLAGS += -Wno-mismatched-tags
else
BASE_FLAGS += -Wno-maybe-uninitialized
BASE_FLAGS += -Wno-unused-but-set-variable
endif # MACOS
ifeq ($(WINDOWS),true)
BASE_FLAGS += -Wno-cast-function-type
BASE_FLAGS += -Wno-unknown-pragmas
else
BASE_FLAGS += -Wno-unused-function
endif # WINDOWS

# openmp (optional)
ifeq ($(DISABLE_OPENMP),)
ifneq ($(MACOS),true)
CUSTOM_BUILD_FLAGS += -D_OPENMP -fopenmp
CUSTOM_LINK_FLAGS  += -fopenmp
endif # MACOS
endif # DISABLE_OPENMP

# extra linker flags
ifneq ($(HAIKU_OR_MACOS_OR_WINDOWS),true)
LINK_FLAGS += -ldl
endif
ifeq ($(WINDOWS),true)
LINK_FLAGS += -lpsapi
endif

endif # HAVE_PROJECTM

LINK_FLAGS += -lpthread

# --------------------------------------------------------------
# Enable all possible plugin types

TARGETS = lv2 vst2 vst3 clap

all: $(TARGETS)

# --------------------------------------------------------------

=== plugins/glBars/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#

# --------------------------------------------------------------
# Project name, used for binaries

NAME = glBars

# --------------------------------------------------------------
# Files to build

FILES_DSP = \
	DistrhoPluginGLBars.cpp

FILES_UI  = \
	DistrhoUIGLBars.cpp

# --------------------------------------------------------------
# Do some magic

FILE_BROWSER_DISABLED = true
include ../../dpf/Makefile.plugins.mk

# --------------------------------------------------------------
# Extra flags

LINK_FLAGS += -lpthread

# --------------------------------------------------------------
# Enable all possible plugin types

TARGETS = jack lv2 vst2 vst3 clap

all: $(TARGETS)

# --------------------------------------------------------------

=== plugins/pitchshift/Makefile ===
#!/usr/bin/make -f
# Makefile for DISTRHO Plugins #
# ---------------------------- #
# Created by falkTX
#

# --------------------------------------------------------------
# Project name, used for binaries

NAME = MaPitchshift

# --------------------------------------------------------------
# Files to build

FILES_DSP = \
	DistrhoPluginMaxGen.cpp

# --------------------------------------------------------------
# Do some magic

include ../../dpf/Makefile.plugins.mk

# --------------------------------------------------------------
# Extra flags

BUILD_CXX_FLAGS += -I../common -I../common/gen_dsp
BUILD_CXX_FLAGS += -Wno-unused-parameter

# --------------------------------------------------------------
# Enable all possible plugin types

all: jack ladspa lv2_dsp vst2 vst3 clap

# --------------------------------------------------------------

=== plugins/ProM/projectM/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14 FATAL_ERROR)

if(CMAKE_VERSION VERSION_LESS 3.19 AND CMAKE_GENERATOR STREQUAL "Xcode")
    message(AUTHOR_WARNING "Using a CMake version before 3.19 with a recent Xcode SDK and the Xcode generator "
            "will likely result in CMake failing to find the AppleClang compiler. Either upgrade CMake to at least "
            "version 3.19 or use a different generator, e.g. \"Unix Makefiles\" or \"Ninja\".")
endif()

include(CMakeDependentOption)
include(CheckSymbolExists)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_POSITION_INDEPENDENT_CODE YES)

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

option(ENABLE_DEBUG_POSTFIX "Add \"d\" after library names for debug builds" ON)
if(ENABLE_DEBUG_POSTFIX)
    set(CMAKE_DEBUG_POSTFIX d)
endif()

# The API (SO) and detailed library versions for the shared library.
set(PROJECTM_SO_VERSION "3")
set(PROJECTM_LIB_VERSION "3.1.1")

project(projectm
        LANGUAGES C CXX
        VERSION 3.1.13
        )

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

set(PROJECTM_BIN_DIR "bin" CACHE STRING "Executable installation directory, relative to the install prefix.")
set(PROJECTM_DATADIR_PATH "share/projectM" CACHE STRING "Default (absolute) path to the projectM data files (presets etc.)")
set(PROJECTM_LIB_DIR "lib" CACHE STRING "Library installation directory, relative to the install prefix.")
set(PROJECTM_INCLUDE_DIR "include" CACHE STRING "Header installation directory, relative to the install prefix.")

# Feature options, including dependencies.
option(ENABLE_STATIC_LIB "Build and install libprojectM as a static library" ON)
cmake_dependent_option(ENABLE_SHARED_LIB "Build and install libprojectM as a shared library" ON "NOT CMAKE_SYSTEM_NAME STREQUAL Windows" OFF)
cmake_dependent_option(ENABLE_SHARED_LINKING "Link all built UI applications against the shared library." OFF "ENABLE_SHARED_LIB" OFF)
option(ENABLE_DOXYGEN "Build and install Doxygen source code documentation in PROJECTM_DATADIR_PATH/docs." OFF)
option(ENABLE_CXX_INTERFACE "Enable exporting all C++ symbols, not only the C API, in the shared library. Warning: This is not very portable." OFF)
option(ENABLE_PRESETS "Build and install bundled presets" ON)
option(ENABLE_NATIVE_PRESETS "Build and install native libraries written in C/C++" OFF)
option(ENABLE_TESTING "Build and install the projectM test suite" OFF)
option(ENABLE_EMSCRIPTEN "Build for web with emscripten" OFF)
cmake_dependent_option(ENABLE_SDL "Enable SDL2 support" ON "NOT ENABLE_EMSCRIPTEN;NOT ENABLE_TESTING" ON)
cmake_dependent_option(ENABLE_SDL_UI "Build the SDL2-based reference UI" ON "NOT ENABLE_EMSCRIPTEN" OFF)
cmake_dependent_option(ENABLE_GLES "Enable OpenGL ES support" OFF "NOT ENABLE_EMSCRIPTEN" ON)
cmake_dependent_option(ENABLE_THREADING "Enable multithreading support" ON "NOT ENABLE_EMSCRIPTEN;NOT CMAKE_SYSTEM_NAME STREQUAL Windows" OFF)
cmake_dependent_option(ENABLE_PULSEAUDIO "Build PulseAudio-based Qt UI" OFF "NOT ENABLE_EMSCRIPTEN;CMAKE_SYSTEM_NAME STREQUAL Linux" OFF)
cmake_dependent_option(ENABLE_JACK "Build JACK-based Qt and SDL UIs" OFF "NOT ENABLE_EMSCRIPTEN;CMAKE_SYSTEM_NAME STREQUAL Linux" OFF)
cmake_dependent_option(ENABLE_QT "Build Qt UI library" OFF "NOT ENABLE_PULSEAUDIO;NOT ENABLE_JACK" ON)
cmake_dependent_option(ENABLE_LLVM "Enable LLVM JIT support" OFF "NOT ENABLE_EMSCRIPTEN" OFF)
cmake_dependent_option(ENABLE_LIBVISUAL "Build and install the projectM libvisual plug-in" OFF "NOT ENABLE_EMSCRIPTEN;CMAKE_SYSTEM_NAME STREQUAL Linux" OFF)

if(NOT ENABLE_STATIC_LIB AND NOT ENABLE_SHARED_LIB)
    message(FATAL_ERROR "At least one of either ENABLE_STATIC_LIB or ENABLE_SHARED_LIB options must be set to ON.")
endif()

if(ENABLE_DOXYGEN)
    find_package(Doxygen REQUIRED)
endif()

find_package(GLM)
if(NOT TARGET GLM::GLM)
    add_library(GLM::GLM INTERFACE IMPORTED)
    set_target_properties(GLM::GLM PROPERTIES
            INTERFACE_INCLUDE_DIRECTORIES "${CMAKE_SOURCE_DIR}/vendor"
            )

    message(STATUS "GLM library not found, using bundled version.")
    set(USE_SYSTEM_GLM OFF)
else()
    set(USE_SYSTEM_GLM ON)
endif()

if(ENABLE_EMSCRIPTEN)
    message(STATUS "${CMAKE_C_COMPILER}")
    check_symbol_exists(__EMSCRIPTEN__ "" HAVE_EMSCRIPTEN)
    if(NOT HAVE_EMSCRIPTEN)
        message(FATAL_ERROR "You are not using an emscripten compiler.")
    endif()
endif()

if(ENABLE_SDL)
    find_package(SDL2 REQUIRED)

    # Apply some fixes, as SDL2's CMake support is new and still a WiP.
    include(SDL2Target)
endif()

if(ENABLE_GLES)
    # Might be implemented in the CMake OpenGL module.
    # We may provide a find module in the future, and add support for CMake's own module later:
    # https://gitlab.kitware.com/cmake/cmake/-/blob/3fc3b43933d0b486aa4eb5d63fc257475feff348/Modules/FindOpenGL.cmake#L520
    message(FATAL_ERROR "GLES support is currently not implemented for CMake builds.")
    find_package(GLES3 REQUIRED)
else()
    find_package(OpenGL REQUIRED)
    set(PROJECTM_OPENGL_LIBRARIES OpenGL::GL)
    # GLX is required by SOIL2 on platforms with the X Window System (e.g. most Linux distributions)
    if(TARGET OpenGL::GLX)
        list(APPEND PROJECTM_OPENGL_LIBRARIES OpenGL::GLX)
    endif()
    if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
        find_package(GLEW REQUIRED)
        list(APPEND PROJECTM_OPENGL_LIBRARIES GLEW::glew)
    endif()
endif()

if(ENABLE_THREADING)
    set(CMAKE_THREAD_PREFER_PTHREAD YES)
    find_package(Threads REQUIRED)
    if(NOT CMAKE_USE_PTHREADS_INIT)
        message(FATAL_ERROR "Threading support requested - pthread support is required, but not available.")
    endif()
    set(USE_THREADS YES)
endif()

if(ENABLE_LLVM)
    find_package(LLVM REQUIRED)
    if(LLVM_VERSION VERSION_LESS 10.0)
        message(FATAL_ERROR "LLVM JIT support requires at least version 10.0, but only ${LLVM_VERSION} was found.")
    endif()
    set(HAVE_LLVM TRUE)
else()
    unset(HAVE_LLVM)
endif()

if(ENABLE_PULSEAUDIO)
    find_package(Pulseaudio REQUIRED)
endif()

if(ENABLE_JACK)
    find_package(JACK REQUIRED)
endif()

if(ENABLE_PULSEAUDIO OR ENABLE_JACK)
    set(QT_REQUIRED_COMPONENTS Gui Widgets OpenGL Xml)
    if(DEFINED QT_VERSION)
        find_package(Qt${QT_VERSION} REQUIRED COMPONENTS ${QT_REQUIRED_COMPONENTS})
    else()
        # Try to determine the Qt version available, starting with Qt6
        message(STATUS "Determining Qt version. To use a specific version, set QT_VERSION to either 5 or 6.")
        find_package(Qt6 QUIET COMPONENTS ${QT_REQUIRED_COMPONENTS})
        if(TARGET Qt6::Core)
            set(QT_VERSION 6)
        else()
            find_package(Qt5 QUIET COMPONENTS ${QT_REQUIRED_COMPONENTS})
            if(TARGET Qt5::Core)
                set(QT_VERSION 5)
            else()
                message(FATAL_ERROR "Could not find either Qt 5 or 6, one is required to build the PulseAudio or JACK UIs.")
            endif()
        endif()
    endif()

    # OpenGLWidgets were put into their own component since Qt 6.
    if(QT_VERSION EQUAL 6)
        list(APPEND QT_REQUIRED_COMPONENTS OpenGLWidgets)
        find_package(Qt6 REQUIRED COMPONENTS OpenGLWidgets)
    endif()

    set(QT_LINK_TARGETS "")
    foreach(component ${QT_REQUIRED_COMPONENTS})
        list(APPEND QT_LINK_TARGETS Qt${QT_VERSION}::${component})
    endforeach()
endif()

if(ENABLE_LIBVISUAL)
    find_package(libvisual REQUIRED)
    set(PROJECTM_LIBVISUAL_DIR "${LIBVISUAL_PLUGINSBASEDIR}/actor" CACHE STRING "Installation directory for the libvisual plug-in library.")
endif()

if(ENABLE_CXX_INTERFACE)
    set(CMAKE_C_VISIBILITY_PRESET default)
    set(CMAKE_CXX_VISIBILITY_PRESET default)
    set(CMAKE_VISIBILITY_INLINES_HIDDEN OFF)
else()
    set(CMAKE_C_VISIBILITY_PRESET hidden)
    set(CMAKE_CXX_VISIBILITY_PRESET hidden)
    set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)
endif()

include(features.cmake)

add_subdirectory(presets)
add_subdirectory(src)

message(STATUS "")
message(STATUS "projectM v${PROJECT_VERSION}")
message(STATUS "==============================================")
message(STATUS "")
message(STATUS "    prefix:                  ${CMAKE_INSTALL_PREFIX}")
message(STATUS "    libdir:                  ${PROJECTM_LIB_DIR}")
message(STATUS "    includedir:              ${PROJECTM_INCLUDE_DIR}")
message(STATUS "    bindir:                  ${PROJECTM_BIN_DIR}")
message(STATUS "    libvisual plugin dir:    ${PROJECTM_LIBVISUAL_DIR}")
message(STATUS "")
message(STATUS "    compiler:                ${CMAKE_CXX_COMPILER}")
message(STATUS "    cflags:                  ${CMAKE_C_FLAGS}")
message(STATUS "    cxxflags:                ${CMAKE_CXX_FLAGS}")
message(STATUS "    ldflags:                 ${CMAKE_SHARED_LINKER_FLAGS}")
message(STATUS "")
message(STATUS "    DATADIR_PATH:            ${PROJECTM_DATADIR_PATH}")
message(STATUS "")
message(STATUS "Features:")
message(STATUS "==============================================")
message(STATUS "")
message(STATUS "    Presets:                 ${ENABLE_PRESETS}")
message(STATUS "    Native presets:          ${ENABLE_NATIVE_PRESETS}")
message(STATUS "    Threading:               ${ENABLE_THREADING}")
message(STATUS "    SDL2:                    ${ENABLE_SDL}")
if(ENABLE_SDL)
    message(STATUS "        SDL2 version:        ${SDL2_VERSION}")
endif()
message(STATUS "    OpenGLES:                ${ENABLE_GLES}")
message(STATUS "    Emscripten:              ${ENABLE_EMSCRIPTEN}")
message(STATUS "    LLVM JIT:                ${ENABLE_LLVM}")
if(ENABLE_LLVM)
    message(STATUS "        LLVM version:        ${LLVM_VERSION}")
endif()
message(STATUS "    Use system GLM:          ${USE_SYSTEM_GLM}")
message(STATUS "    Link UI with shared lib: ${ENABLE_SHARED_LINKING}")
message(STATUS "")
message(STATUS "Targets and applications:")
message(STATUS "==============================================")
message(STATUS "")
message(STATUS "    libprojectM static:      ${ENABLE_STATIC_LIB}")
message(STATUS "    libprojectM shared:      ${ENABLE_SHARED_LIB}")
message(STATUS "    SDL2 UI:                 ${ENABLE_SDL_UI}")
message(STATUS "    Doxygen API docs:        ${ENABLE_DOXYGEN}")
message(STATUS "    Tests:                   ${ENABLE_TESTING}")
message(STATUS "    PulseAudio UI:           ${ENABLE_PULSEAUDIO}")
if(ENABLE_PULSEAUDIO)
    message(STATUS "        PulseAudio version:  ${PULSEAUDIO_VERSION}")
endif()
message(STATUS "    JACK UI:                 ${ENABLE_JACK}")
if(ENABLE_JACK)
    message(STATUS "        JACK version:        ${JACK_VERSION}")
endif()
if(ENABLE_PULSEAUDIO OR ENABLE_JACK)
    message(STATUS "    Qt version:              ${Qt${QT_VERSION}_VERSION}")
endif()
message(STATUS "    libvisual plug-in:       ${ENABLE_LIBVISUAL}")
message(STATUS "")

message(AUTHOR_WARNING
        "The CMake build scripts for projectM are still in active development.\n"
        "This means that build parameters, exported target names and other things can change "
        "at any time until the new build system is officially documented and announced to be "
        "fully supported.\n"
        "DO NOT base any production work on it yet!\n"
        )

if(ENABLE_CXX_INTERFACE)
    message(AUTHOR_WARNING "This build is configured to export all C++ symbols in the shared library.\n"
            "Using C++ STL types across library borders only works if all components were built "
            "with the exact same toolchain and C++ language level, otherwise it will cause crashes.\n"
            "Enabling this option will not export additional symbols in Windows DLL builds.\n"
            "Only use this if you know what you're doing. You have been warned!"
            )
endif()

# Create CPack configuration
set(CPACK_PACKAGE_NAME "projectM")
set(CPACK_VERBATIM_VARIABLES YES)
include(CPack)

=== plugins/ProM/projectM/src/CMakeLists.txt ===
add_subdirectory(libprojectM)
add_subdirectory(NativePresets)
add_subdirectory(projectM-qt)
add_subdirectory(projectM-jack)
add_subdirectory(projectM-libvisual)
add_subdirectory(projectM-pulseaudio)
add_subdirectory(projectM-sdl)
add_subdirectory(projectM-test)

=== plugins/ProM/projectM/src/projectM-jack/CMakeLists.txt ===
if(NOT ENABLE_JACK)
    return()
endif()

if(ENABLE_QT)
    include(projectM-jack-qt.cmake)
endif()

if(ENABLE_SDL)
    include(projectM-jack-sdl.cmake)
endif()

=== debian/changelog ===
dpf-plugins (1.6+ds-2) unstable; urgency=medium

  * Fix FTBS on armel
  * Add libglm-dev, libxcursor-dev & libxrandr-de to B-Ds
  * Remove libjack-dev from B-Ds
    + https://github.com/DISTRHO/DPF-Plugins/issues/23#issuecomment-1360298123
  * Change my email address

 -- Dennis Braun <snd@debian.org>  Wed, 21 Dec 2022 20:00:58 +0100

dpf-plugins (1.6+ds-1) unstable; urgency=medium

  * New upstream version 1.6

  [ Dennis Braun ]
  * Introduce the dpf-source package, sources of the DISTRHO Plugin Framework
  * Build verbose, and try to fix CPPFLAGS missing
  * Refresh patchset, use rtmidi from system too
  * Prefer libjack-dev over libjack-jackd2-dev

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Fix passing of *FLAGS
  * Verbose builds
  * Replace dh_auto_install override with an execute_after
  * Allow for cross-compilation
  * Do not optimized binaries beyond our base architecture
  * Pass CPPFLAGS via CFLAGS/CXXFLAGS
  * Make sure to leave the sources in a pristine state
  * Make blhc ignore lines starting with "Compiling ..."

  [ Dennis Braun ]
  * d/not-installed: clap and vst3 format is so far not in use
  * d/copyright: Remove obsolete vestige entry
  * Use DejaVuSans from fonts-dejavu-core
  * Refresh lintian-overrides

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Update d/copyright
    + Exclude binary artifacts from the package import
    + Fix typo in upstream URL
    + Add 'licensecheck' target to d/rules
    + Generate d/copyright_hints
  * Automatically add repacksuffix when importing new upstream sources

 -- Dennis Braun <snd@debian.org>  Sun, 18 Dec 2022 21:56:25 +0100

=== debian/control ===
Source: dpf-plugins
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Dennis Braun <snd@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libgl1-mesa-dev,
 libglm-dev,
 libglu1-mesa-dev,
 liblo-dev,
 libprojectm-dev,
 librtaudio-dev,
 librtmidi-dev,
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxrandr-dev,
 pkg-config,
Homepage: https://github.com/falkTX/DPF-Plugins
Vcs-Git: https://salsa.debian.org/multimedia-team/dpf-plugins.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/dpf-plugins
Standards-Version: 4.6.1
Rules-Requires-Root: no

Package: dpf-plugins
Architecture: any
Depends:
 dpf-plugins-common,
 dpf-plugins-dssi,
 dpf-plugins-ladspa,
 dpf-plugins-lv2,
 dpf-plugins-vst,
 ${misc:Depends},
Description: Audio plugin collection from DISTRHO (metapackage)
 Metapackage pulling-in collection of DPF-based plugins in
 LADSPA, DSSI, LV2 and VST2 formats.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-common
Architecture: any
Depends:
 projectm-data,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Audio plugin collection from DISTRHO (common files)
 Common files for collection of DPF-based plugins in
 LADSPA, DSSI, LV2 and VST2 formats.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-ladspa
Architecture: any
Depends:
 dpf-plugins-common,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 ladspa-plugin,
Description: Audio plugin collection from DISTRHO (LADSPA plugins)
 Collection of DPF-based plugins in LADSPA format.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-lv2
Architecture: any
Depends:
 dpf-plugins-common,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 lv2-plugin,
Description: Audio plugin collection from DISTRHO (LV2 plugins)
 Collection of DPF-based plugins in LV2 format.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-vst
Architecture: any
Depends:
 dpf-plugins-common,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 vst-plugin,
Description: Audio plugin collection from DISTRHO (VST2 plugins)
 Collection of DPF-based plugins in VST2 format.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-plugins-dssi
Architecture: any
Depends:
 dpf-plugins-common,
 ${misc:Depends},
 ${shlibs:Depends},
Provides:
 dssi-plugin,
Description: Audio plugin collection from DISTRHO (DSSI plugins)
 Collection of DPF-based plugins in DSSI format.
 .
 The list of plugins/packs are:
  - glBars
  - Kars
  - Mini-Series (3BandEQ, 3BandSplitter, PingPongPan)
  - ndc-Plugs (Amplitude Imposer, Cycle Shifter, Soul Force)
  - MVerb
  - Nekobi
  - ProM

Package: dpf-source
Architecture: all
Depends:
 fonts-dejavu-core,
 python3:any,
 ${misc:Depends},
Description: DISTRHO Plugin Framework (Source files)
 DPF is designed to make development of new plugins an easy
 and enjoyable task.
 It allows developers to create plugins with custom UIs
 using a simple C++ API.
 The framework facilitates exporting various different
 plugin formats from the same code-base.

## dpf-plugins 1.7%2Bds

=== debian/changelog ===
dpf-plugins (1.7+ds-3build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 16 Jan 2026 20:26:48 +0000

dpf-plugins (1.7+ds-3) unstable; urgency=medium

  [ IOhannes m zmölnig (Debian/GNU) ]
  * Also link against system's RtAudio
  * Add patch to fix compilation with RtAudio6 (Closes: #1051558)
  * Bump standards version to 4.7.0
  * Apply 'wrap-and-sort -ast'

  [ Dennis Braun ]
  * Change B-D from pkg-config to pkgconf
  * Use default salsa ci config

 -- Dennis Braun <snd@debian.org>  Sat, 17 Aug 2024 14:35:06 +0200

dpf-plugins (1.7+ds-2) unstable; urgency=medium

  * Source-only upload

 -- Dennis Braun <snd@debian.org>  Sun, 27 Aug 2023 23:49:43 +0200

dpf-plugins (1.7+ds-1) unstable; urgency=medium

  [ Olivier Humbert ]
  * d/control: update Homepage link

  [ Dennis Braun ]
  * New upstream version 1.7+ds
  * Build-Depends: libgl1-mesa-dev => libgl-dev
  * Bump Standards-Version to 4.6.2
  * Provide the clap package of dpf-plugins
  * Provide the vst3 package of dpf-plugins
  * Add the new plugin packages to the Depends of the meta package
  * Refresh patches, drop armel patch applied by upstream
  * d/copyright: Refresh file entries, bump years

 -- Dennis Braun <snd@debian.org>  Thu, 27 Jul 2023 16:04:49 +0200
